Getting Started with ReactJS TreeGrid

6 Jun 20239 minutes to read

This section helps to understand the getting started of the React JS TreeGrid with the step-by-step instructions.

Create your first TreeGrid in React JS

To get started Syncfusion React JS application refer this page for basic control integration and script references.

The Essential React JS TreeGrid has been designed to represent and edit the hierarchical data.

This section explains how to create a TreeGrid widget in your application with hierarchical data source and enable sorting and editing. The following screenshot displays the output.

ReactJS TreeGrid Getting Started

The required ReactJS script dependencies as follows. And you can also refer React to know more about react js.

1.Create HTML file and add the following necessary script and css files to the HTML file.

  • HTML
  • <!DOCTYPE html>
        <html xmlns="http://www.w3.org/1999/xhtml">
            <head>
                <meta name="viewport"content="width=device-width, initial-scale=1.0"/>
                <meta charset="utf-8" />
                <link href=" http://cdn.syncfusion.com/28.1.33/js/web/flat-azure/ej.web.all.min.css" rel="stylesheet"/>
                <script src="http://cdn.syncfusion.com/js/assets/external/react.min.js"></script>        
                <script src="http://cdn.syncfusion.com/js/assets/external/react-dom.min.js"></script>        
                <script src="https://cdnjs.cloudflare.com/ajax/libs/babel-core/5.8.34/browser.min.js"></script>
                <script src="http://cdn.syncfusion.com/js/assets/external/jquery-1.10.2.min.js"></script>
                <script src="http://cdn.syncfusion.com/js/assets/external/jsrender.min.js"></script>
                <script src="http://cdn.syncfusion.com/js/assets/external/jquery.globalize.min.js"></script>
                <script src="http://cdn.syncfusion.com/js/assets/external/jquery.easing.1.3.min.js"></script>
                <script src="http://cdn.syncfusion.com/28.1.33/js/web/ej.web.all.min.js" type="text/javascript"></script>
                <script src="http://cdn.syncfusion.com/28.1.33/js/common/ej.web.react.min.js"></script>
            </head>
            <body>
            <!--Add TreeGrid control here -->
            </body>
        </html>

    Create a TreeGrid

    Control can be initialized in two ways.

    • Using jsx Template
    • Without using jsx Template

    Using jsx Template

    By using the jsx template, we can create the html file and jsx file. The .jsx file can be convert to .js file and it can be referred in html page.

    Please refer to the code of HTML file.

  • HTML
  • <div id="TreeGrid-default"></div>
           <script type="text/babel" src="app.jsx">
           </script>

    Create an app.JSX file and paste the following content

  • JS
  • var ProjectData = [{
        taskID: 2,
        taskName: "Planning",
        startDate: "02/03/2014",
        endDate: "02/07/2014",
        duration: 10,
        progress: 56,
        subtasks: [{
            taskID: 3,
            taskName: "Plan timeline",
            startDate: "02/03/2014",
            endDate: "02/07/2014",
            duration: 5,
            progress: "100"
        }, 
        //...
    }]
    var columns = [{ field: 'taskID', headerText: 'Task Id', width: '45'}, 
                    { field: 'taskName', headerText: 'Task Name'},
                    { field: 'startDate', headerText: 'Start Date'},
                    { field: 'endDate', headerText: 'End Date'},
                    { field: 'duration', headerText: 'Duration'},
                    { field: 'progress', headerText: 'Progress'}
                   ];
    		ReactDOM.render(
    <EJ.TreeGrid dataSource={projectData} childMapping="subtasks" columns={columns} treeColumnIndex={1}>
       
    </EJ.TreeGrid>,
       document.getElementById('TreeGrid-default')
    );

    TreeGrid widget is displayed as the output in the following screenshot.

    ReactJS TreeGrid Using jsx Template

    Enable Sorting

    The TreeGrid control has sorting functionality, to arrange the data in ascending or descending order based on a particular column.

    Multicolumn Sorting

    Enable the multicolumn sorting in TreeGrid by setting allowMultiSorting as true. You can sort multiple columns in TreeGrid, by selecting the desired column header while holding the Ctrl key.

  • JS
  • ReactDOM.render(
    <EJ.TreeGrid allowSorting={true} allowMultiSorting={true}>
       
    </EJ.TreeGrid>,
       document.getElementById('TreeGrid-default')
    );

    ReactJS TreeGrid Multicolumn Sorting

    Enable Editing

    You can enable Editing in TreeGrid by using the editSettings property as follows.

  • JS
  • var editSettings = {
                allowAdding: true,
                allowEditing: true,
                allowDeleting: true,
                editMode: 'cellEditing',
                rowPosition: 'belowSelectedRow'
            };
    		ReactDOM.render(
    <EJ.TreeGrid editSettings={editSettings} >
       
    </EJ.TreeGrid>,
       document.getElementById('TreeGrid-default')
    );

    And also, the following editors are provided for editing support in TreeGrid control.

    • string
    • boolean
    • numeric
    • dropdown
    • datepicker
    • datetimepicker

    You can set the editor type for a particular column as follows.

  • JS
  • var ProjectData = [{
        taskID: 2,
        taskName: "Planning",
        startDate: "02/03/2014",
        endDate: "02/07/2014",
        duration: 10,
        progress: 56,
        subtasks: [{
            taskID: 3,
            taskName: "Plan timeline",
            startDate: "02/03/2014",
            endDate: "02/07/2014",
            duration: 5,
            progress: "100"
        }, 
        //...
    }]
    var columns = [{ field: 'taskID', headerText: 'Task Id', width: '45', editType: 'numericedit' },
                        { field: 'taskName', headerText: 'Task Name', editType: 'stringedit' },
                        { field: 'startDate', headerText: 'Start Date', editType: 'datepicker' },
                        { field: 'endDate', headerText: 'End Date', editType: 'datepicker'},
                        { field: 'duration', headerText: 'Duration', editType: 'numericedit' },
                        { field: 'progress', headerText: 'Progress', editType: 'numericedit' }
                   ];
    		ReactDOM.render(
    <EJ.TreeGrid columns={columns}>
       
    </EJ.TreeGrid>,
       document.getElementById('TreeGrid-default')
    );

    The output of the DateTimePicker editor in TreeGrid control is as follows.

    ReactJS TreeGrid Enable Editing

Getting Started

17 Jul 20189 minutes to read

This section helps to understand the getting started of the Angular TreeGrid with the step-by-step instructions.

Create your first TreeGrid in Angular

Getting started with SystemJS

To quick start with Syncfusion JavaScript Angular components run the below commands to clone the repository for SystemJS starter and installing required dependency packages.

  • JAVASCRIPT
  • > git clone https://github.com/syncfusion/angular2-seeds/ -b systemjs
    
     > cd angular2-seeds
    
     > npm install

    The below steps describes to add component with above cloned seed application.

    Syncfusion JavaScript components source configuration and sample creation

    • Copy required Syncfusion Angular source component(s) from the below build location and add it in src/ej folder (For ex., consider the TreeGrid component).
  • JAVASCRIPT
  • (Installed Location)\Syncfusion\Essential Studio\21.1.35\JavaScript\assets-src\angular2\

    NOTE

    core.ts file is mandatory for all Syncfusion JavaScript Angular components. The repository having the source file from Essential Studio for JavaScript v21.1.35.

    • Create TreeGrid folder inside src folder.

    • Create TreeGrid.component.html view file inside src/TreeGrid folder and render ejTreeGrid Angular component using the below code example.

  • HTML
  • <ej-treegrid id="TreeGridControl" [dataSource]="treeGridData" childMapping="subtasks" [treeColumnIndex]=treeColumnIndex sizeSettings.height="400px"
        sizeSettings.width="100%">
        <e-treegrid-columns>
            <e-treegrid-column field="taskID" headerText="Task ID"></e-treegrid-column>
            <e-treegrid-column field="taskName" headerText="TaskName"></e-treegrid-column>
            <e-treegrid-column field="startDate" headerText="Start Date"></e-treegrid-column>
            <e-treegrid-column field="endDate" headerText="End Date"></e-treegrid-column>
            <e-treegrid-column field="duration" headerText="Duration"></e-treegrid-column>
            <e-treegrid-column field="progress" headerText="Progress"></e-treegrid-column>
        </e-treegrid-columns>
    </ej-treegrid>
    • Create TreeGrid.component.ts model file inside the folder src/TreeGrid and create sample component using the below code example.
  • JAVASCRIPT
  • import { Component } from '@angular/core';
    
    @Component({
      selector: 'ej-app',
      templateUrl: 'app/components/treeGrid/treeGrid.component.html',
      styleUrls: ['app/components/treeGrid/treeGrid.component.css'], 
    })
    
    export class DefaultComponent {
    
        this.treeGridData =  [{
             taskID: 1,
             taskName: "Planning",
             startDate: "02/03/2014",
             endDate: "02/07/2014",
             progress: 100,
             duration: 5,
             subtasks: [
                 { taskID: 2, taskName: "Plan timeline", startDate: "02/03/2014", endDate: "02/07/2014", duration: 5, progress: 100 },
                 { taskID: 3, taskName: "Plan budget", startDate: "02/03/2014", endDate: "02/07/2014", duration: 5 },
                 { taskID: 4, taskName: "Allocate resources", startDate: "02/03/2014", endDate: "02/07/2014", duration: 5, progress: 100 },
                 { taskID: 5, taskName: "Planning complete", startDate: "02/07/2014", endDate: "02/07/2014", duration: 0, progress: 0 }
             ]
         }]  
      public treeColumnIndex = 1;
    }

    Configure the routes for the Router

    Before adding router configuration for above created ejTreeGrid component, we recommend you to go through the Angular Routing configuration to get the deeper knowledge about Angular routing.

    • Now, we are going to configure the route navigation link for created TreeGrid sample in src/app.component.html file.
  • HTML
  • <div>
    	<ul class="nav navbar-nav">
    		. . . .
    		<li><a data-toggle="collapse" data-target="#skeleton-navigation-navbar-collapse.in" href="#treegrid" [routerLink]="['/treegrid']">TreeGrid </a></li>
    	</ul>
    </div>
    <main>
    	<router-outlet></router-outlet>
    </main>
    • Import the ejTreeGrid sample component and define the route in src/app.routes.ts file.
  • JAVASCRIPT
  • import { Routes } from '@angular/router';
    . . . . 
    import { TreeGridComponent } from './treeGrid/treeGrid.component';
    
    export const rootRouterConfig: Routes = [
        { path: '', redirectTo: 'home', pathMatch: 'full' },
        . . . . 
        { path: 'treeGrid', component: TreeGridComponent }
    ];
    • Import and declare the Syncfusion source component and ejTreeGrid sample component into app.module.ts like the below code snippet.
  • JAVASCRIPT
  • import { NgModule, enableProdMode, ErrorHandler } from '@angular/core';
    . . . . . 
    import { EJ_TREEGRID_COMPONENTS } from './ej/treeGrid.component';
    import { TreeGridComponent } from './treeGrid/treeGrid.component';
    
    import { rootRouterConfig } from './app.routes';
    . . . . 
    @NgModule({
      imports: [BrowserModule, FormsModule, HttpModule, RouterModule.forRoot(rootRouterConfig, { useHash: true })],
      declarations: [. . . . , EJ_TREEGRID_COMPONENTS,TreeGridComponent],
      bootstrap: [AppComponent]
    })
    export class AppModule { }

    A TreeGrid Control is created as shown in the following screen shot.

    Enable Sorting

    The TreeGrid control has sorting functionality, to arrange the data in ascending or descending order based on a particular column.

    Multicolumn Sorting

    Enable the multicolumn sorting in TreeGrid by setting allowMultiSorting as true. You can sort multiple columns in TreeGrid, by selecting the desired column header while holding the Ctrl key.

  • HTML
  • <ej-treegrid id="TreeGridControl" 
        [allowSorting]="true"
        [allowMultiSorting]="true">
    </ej-treegrid>

    Enable Editing

    You can enable Editing in TreeGrid by using the editSettings property as follows.

  • HTML
  • <ej-treegrid id="TreeGridControl" 
        [editSettings]="editSettings"
       >
    </ej-treegrid>
  • JAVASCRIPT
  • import { Component } from '@angular/core';
    
    @Component({
      selector: 'ej-app',
      templateUrl: 'app/components/treeGrid/treeGrid.component.html',
      styleUrls: ['app/components/treeGrid/treeGrid.component.css'], 
    })
    
    export class DefaultComponent {
         this.editSettings = {
                allowAdding: true,
                allowEditing: true,
                allowDeleting: true,
                editMode: 'cellEditing',
                rowPosition: 'belowSelectedRow'
            };
    }

    And also, the following editors are provided for editing support in TreeGrid control.

    • string
    • boolean
    • numeric
    • dropdown
    • datepicker
    • dateTimePicker

    You can set the editor type for a particular column as follows.

  • HTML
  • <ej-treegrid id="TreeGridControl">
        <e-treegrid-columns>
            <e-treegrid-column field="taskID" headerText="Task ID" editType="numericedit"></e-treegrid-column>
            <e-treegrid-column field="taskName" headerText="TaskName" editType="stringedit"></e-treegrid-column>
            <e-treegrid-column field="startDate" headerText="Start Date" editType="datepicker"></e-treegrid-column>
            <e-treegrid-column field="endDate" headerText="End Date" editTyp="datepicker"></e-treegrid-column>
            <e-treegrid-column field="duration" headerText="Duration" editType="numericedit"></e-treegrid-column>
            <e-treegrid-column field="progress" headerText="Progress" editType="numericedit"></e-treegrid-column>
        </e-treegrid-columns>
    </ej-treegrid>

    The output of the DateTimePicker editor in TreeGrid control is as follows.

    Running the application

    • To run the application, execute below command.
  • JAVASCRIPT
  • npm start
    • Browse to http://localhost:3000 to see the application. And navigate to TreeGrid tab. The component is rendered as like the below screenshot. You can make changes in the code found under src folder and the browser should auto-refresh itself while you save files.